require 'ostruct'

module Pagedump
  # WARNING !!
  # Not Thread-Safe
  class Driver
    def self.inherited(subclass)
      Pagedump.register_driver subclass
    end

    def initialize
      @wlinks = {}
      @data = {}
    end

    def data key, value
      @data[key] ||= []
      @data[key] << value
    end

    def link weight, href
      begin
        relative = URI.parse(href)
        abs_link = URI.parse(url).merge(relative).to_s
        @wlinks[abs_link] = weight
      rescue URI::InvalidURIError
        Pagedump.logger.warn "[Driver #{name}] Error parsing href \"#{href}\". Ignoring link (weight was #{weight})"
      end
    end

    def scrap
      @wlinks = {}
      Pagedump.logger.info "Getting headlines for url #{url}"
      agent = Mechanize.new
      page = agent.get(url)
      self.links page
      self.check page
      result = OpenStruct.new
      result.links = @wlinks
      result.data = @data
      result
    end

    def check page
    end

    def url
      self.class::URL
    end

    def name
      self.class.name
    end
  end
end
